=== examples/inline_assembler/simple/CMakeLists.txt ===
add_executable(simple simple.cpp)
