=== debian/changelog ===
nihstro (0.0~git20211107.e924e21-2) unstable; urgency=medium

  * Source only upload.

 -- David James <davidjamescastor215@proton.me>  Thu, 04 Jan 2024 12:58:04 +0000

nihstro (0.0~git20211107.e924e21-1) unstable; urgency=medium

  * Initial release. (Closes: #1056551)

 -- David James <davidjamescastor215@proton.me>  Tue, 21 Nov 2023 18:05:58 +0000
