=== debian/control ===
Source: nihstro
Section: devel
Priority: optional
Maintainer: David James <davidjamescastor215@proton.me>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libboost-dev,
 libboost-test-dev,
 libboost-program-options-dev,
Standards-Version: 4.6.2
Homepage: https://github.com/neobrain/nihstro
Vcs-Browser: https://salsa.debian.org/debian/nihstro
Vcs-Git: https://salsa.debian.org/debian/nihstro.git

Package: nihstro-tools
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: 3DS shader tools
 nihstro is a collection of tools for 3DS shaders targeted at homebrew 
 development and/or reverse engineering. Currently, it supports assembling 
 3DS shader binaries from assembly source code and disassembling shaders from 
 shbin files. It also provides C++ interfaces for analyzing and runtime-
 compiling shaders.

Package: nihstro-headers
Architecture: all
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: 3DS shader development headers
 Headers for development with nihstro
