=== debian/rules ===
#!/usr/bin/make -f

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Package maintainers to append CFLAGS.
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CMAKE_BUILD_OPTIONS := \
    -DCMAKE_INSTALL_PREFIX=/usr

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_BUILD_OPTIONS)

override_dh_auto_install:
	mkdir -p debian/tmp/usr/include
	cp -r include/* debian/tmp/usr/include
	dh_auto_install --destdir=debian/tmp
