=== debian/watch ===
version=4
opts=mode=git \
https://github.com/neobrain/nihstro.git HEAD
