## nihstro 0.0~git20240505.f4d8659

=== debian/changelog ===
nihstro (0.0~git20240505.f4d8659-1) unstable; urgency=medium

  * New upstream version 0.0~git20240505.f4d8659 (Closes: #1110599)
  * Add gbp.conf
  * Add patch to bump minimum CMake version to 3.5 (Closes: #1113325)
  * Update years in d/copyright
  * Remove redundant --as-needed linker flag
  * Changes to d/control
    - Update standards version to 4.7.2
    - Fix trailing whitespace
    - Remove redundant Rules-requires-root
    - Update package description
  * Update d/watch to version 5

 -- David James <davidjamescastor215@proton.me>  Thu, 11 Dec 2025 16:46:44 +0000
