=== debian/rules ===
--- 
+++ 
@@ -5,8 +5,6 @@
 
 # Package maintainers to append CFLAGS.
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
-# Package maintainers to append LDFLAGS.
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 CMAKE_BUILD_OPTIONS := \
     -DCMAKE_INSTALL_PREFIX=/usr
